Index: trunk/LMDZ.GENERIC/libf/phystd/physiq.F90
===================================================================
--- trunk/LMDZ.GENERIC/libf/phystd/physiq.F90	(revision 726)
+++ trunk/LMDZ.GENERIC/libf/phystd/physiq.F90	(revision 728)
@@ -1336,10 +1255,6 @@
             ! note: for now, also changes albedo in the subroutine
 
-            do ig=1,ngrid
-               zdtsurf(ig) = zdtsurf(ig) + zdtsurf_hyd(ig)
-               do iq=1,nq
-                  qsurf(ig,iq) = qsurf(ig,iq)+ptimestep*dqs_hyd(ig,iq)
-               enddo
-            enddo
+            zdtsurf(1:ngridmx) = zdtsurf(1:ngridmx) + zdtsurf_hyd(1:ngridmx)
+            qsurf(1:ngridmx,1:nqmx) = qsurf(1:ngridmx,1:nqmx) + ptimestep*dqs_hyd(1:ngridmx,1:nqmx)
             ! when hydrology is used, other dqsurf tendencies are all added to dqs_hyd inside
 
@@ -1365,9 +1280,5 @@
          ELSE     ! of if (hydrology)
 
-            do iq=1,nq
-               do ig=1,ngrid
-                  qsurf(ig,iq)=qsurf(ig,iq)+ptimestep*dqsurf(ig,iq)
-               enddo
-            enddo           
+            qsurf(1:ngridmx,1:nqmx)=qsurf(1:ngridmx,1:nqmx)+ptimestep*dqsurf(1:ngridmx,1:nqmx)
 
          END IF   ! of if (hydrology)
@@ -1380,7 +1291,5 @@
 
          if(ice_update)then
-            do ig = 1, ngrid
-               ice_min(ig)=min(ice_min(ig),qsurf(ig,igcm_h2o_ice))
-            enddo
+            ice_min(1:ngridmx)=min(ice_min(1:ngridmx),qsurf(1:ngridmx,igcm_h2o_ice))
          endif
 
@@ -1393,7 +1302,5 @@
 
 !     Increment surface temperature
-      do ig=1,ngrid
-         tsurf(ig)=tsurf(ig)+ptimestep*zdtsurf(ig) 
-      enddo
+      tsurf(1:ngridmx)=tsurf(1:ngridmx)+ptimestep*zdtsurf(1:ngridmx) 
 
 !     Compute soil temperatures and subsurface heat flux
@@ -1406,9 +1313,5 @@
 ! test energy conservation
       if(enertest)then
-         dEtots=0.0
-         do ig = 1, ngrid
-            dEtots = dEtots + capcal(ig)*zdtsurf(ig)*area(ig)
-         enddo
-         dEtots=dEtots/totarea
+         dEtots = SUM(area(:)*capcal(:)*zdtsurf(:))/totarea
          print*,'Surface energy change                 =',dEtots,' W m-2'
       endif
@@ -1425,49 +1328,31 @@
  
       ! temperature, zonal and meridional wind
-      do l=1,nlayer
-        do ig=1,ngrid
-          zt(ig,l) = pt(ig,l) + pdt(ig,l)*ptimestep
-          zu(ig,l) = pu(ig,l) + pdu(ig,l)*ptimestep
-          zv(ig,l) = pv(ig,l) + pdv(ig,l)*ptimestep
-
-          ! diagnostic
-          zdtdyn(ig,l)     = ztprevious(ig,l)-pt(ig,l)
-          ztprevious(ig,l) = zt(ig,l)
-        enddo
+      zt(1:ngridmx,1:nlayermx) = pt(1:ngridmx,1:nlayermx) + pdt(1:ngridmx,1:nlayermx)*ptimestep
+      zu(1:ngridmx,1:nlayermx) = pu(1:ngridmx,1:nlayermx) + pdu(1:ngridmx,1:nlayermx)*ptimestep
+      zv(1:ngridmx,1:nlayermx) = pv(1:ngridmx,1:nlayermx) + pdv(1:ngridmx,1:nlayermx)*ptimestep
+
+      ! diagnostic
+      zdtdyn(1:ngridmx,1:nlayermx)     = pt(1:ngridmx,1:nlayermx)-ztprevious(1:ngridmx,1:nlayermx)
+      ztprevious(1:ngridmx,1:nlayermx) = zt(1:ngridmx,1:nlayermx)
+
+      if(firstcall)then
+         zdtdyn(1:ngridmx,1:nlayermx)=0.0
+      endif
+
+      ! dynamical heating diagnostic
+      do ig=1,ngrid
+         fluxdyn(ig)= SUM(zdtdyn(ig,:) *mass(ig,:))*cpp/ptimestep
       enddo
 
-      if(firstcall)then
-         zdtdyn(:,:)=0.0
-      endif
-
-      ! dynamical heating diagnostic
-      fluxdyn(:)=0.
-      do ig=1,ngrid
-         do l=1,nlayer
-            fluxdyn(ig)=fluxdyn(ig) - (zdtdyn(ig,l)/ptimestep)   &
-                 *(pplev(ig,l)-pplev(ig,l+1))*cpp/g
-         enddo
-      enddo
-
       ! tracers
-      do iq=1, nq
-        do l=1,nlayer
-          do ig=1,ngrid
-            zq(ig,l,iq) = pq(ig,l,iq) + pdq(ig,l,iq)*ptimestep
-          enddo
-        enddo
-      enddo
+      zq(1:ngridmx,1:nlayermx,1:nqmx) = pq(1:ngridmx,1:nlayermx,1:nqmx) + pdq(1:ngridmx,1:nlayermx,1:nqmx)*ptimestep
 
       ! surface pressure
-      do ig=1,ngrid
-          ps(ig) = pplev(ig,1) + pdpsrf(ig)*ptimestep
-      enddo
+      ps(1:ngridmx) = pplev(1:ngridmx,1) + pdpsrf(1:ngridmx)*ptimestep
 
       ! pressure
       do l=1,nlayer
-        do ig=1,ngrid
-             zplev(ig,l) = pplev(ig,l)/pplev(ig,1)*ps(ig)
-             zplay(ig,l) = pplay(ig,l)/pplev(ig,1)*ps(ig)
-        enddo
+          zplev(1:ngridmx,l) = pplev(1:ngridmx,l)/pplev(1:ngridmx,1)*ps(:)
+          zplay(1:ngridmx,l) = pplay(1:ngridmx,l)/pplev(1:ngridmx,1)*ps(1:ngridmx)
       enddo
 
@@ -1558,30 +1443,25 @@
 !     ---------------------------------------------------------
       if(tracer)then
-         qcol(:,:)=0.0
+         qcol(1:ngridmx,1:nqmx)=0.0
          do iq=1,nq
-            do ig=1,ngrid
-               do l=1,nlayer
-                  qcol(ig,iq) = qcol(ig,iq) + zq(ig,l,iq) *    &
-                            (pplev(ig,l) - pplev(ig,l+1)) / g
-               enddo
+           do ig=1,ngridmx
+              qcol(ig,iq) = SUM( zq(ig,1:nlayermx,iq) * mass(ig,1:nlayermx))
+           enddo
+         enddo
+
+         ! Generalised for arbitrary aerosols now. (LK)
+         reffcol(1:ngridmx,1:naerkind)=0.0
+         if(co2cond.and.(iaero_co2.ne.0))then
+            call co2_reffrad(zq,reffrad)
+            do ig=1,ngridmx
+               reffcol(ig,iaero_co2) = SUM(zq(ig,1:nlayermx,igcm_co2_ice)*reffrad(ig,1:nlayermx,iaero_co2)*mass(ig,1:nlayermx))
             enddo
-         enddo
-
-         ! Generalised for arbitrary aerosols now. (LK)
-         reffcol(:,:)=0.0
-         do ig=1,ngrid
-            do l=1,nlayer
-               if(co2cond.and.(iaero_co2.ne.0)) then
-                  reffcol(ig,iaero_co2) = reffcol(ig,iaero_co2) + zq(ig,l,igcm_co2_ice) * &
-                                  reffrad(ig,l,iaero_co2) *    &
-                                  (pplev(ig,l) - pplev(ig,l+1)) / g
-               endif
-               if(water.and.(iaero_h2o.ne.0)) then
-                  reffcol(ig,iaero_h2o) = reffcol(ig,iaero_h2o) + zq(ig,l,igcm_h2o_ice) * &
-                                  reffrad(ig,l,iaero_h2o) *    &
-                                  (pplev(ig,l) - pplev(ig,l+1)) / g
-               endif
+         endif
+         if(water.and.(iaero_h2o.ne.0))then
+            call h2o_reffrad(zq,zt,reffrad,nueffrad)
+            do ig=1,ngridmx
+               reffcol(ig,iaero_h2o) = SUM(zq(ig,1:nlayermx,igcm_h2o_ice)*reffrad(ig,1:nlayermx,iaero_h2o)*mass(ig,1:nlayermx))
             enddo
-         enddo
+         endif
 
       endif
@@ -1622,5 +1502,7 @@
          do l = 1, nlayer
             do ig = 1, ngrid
-               call watersat(pt(ig,l),pplay(ig,l),qsat(ig,l))
+!               call watersat(pt(ig,l),pplay(ig,l),qsat(ig,l))
+               call Psat_water(zt(ig,l),pplay(ig,l),psat_tmp,qsat(ig,l))
+
                RH(ig,l) = zq(ig,l,igcm_h2o_vap) / qsat(ig,l)
             enddo
@@ -1629,9 +1511,5 @@
          ! compute maximum possible H2O column amount (100% saturation)
          do ig=1,ngrid
-            H2Omaxcol(ig)=0.0
-            do l=1,nlayer
-               H2Omaxcol(ig) = H2Omaxcol(ig) + qsat(ig,l) *    &
-                    (pplev(ig,l) - pplev(ig,l+1))/g
-            enddo
+               H2Omaxcol(ig) = SUM( qsat(ig,:) * mass(ig,:))
          enddo
 
@@ -1662,12 +1540,9 @@
 
                   ! add multiple years of evolution
-                  qsurf_hist(ig,igcm_h2o_ice) = &
-                     !qsurf_hist(ig,igcm_h2o_ice) + delta_ice*100.0 
-                     qsurf_hist(ig,igcm_h2o_ice) + delta_ice*icetstep 
+                  qsurf_hist(ig,igcm_h2o_ice) = qsurf_hist(ig,igcm_h2o_ice) + delta_ice*icetstep 
 
                   ! if ice has gone -ve, set to zero
                   if(qsurf_hist(ig,igcm_h2o_ice).lt.0.0)then
                      qsurf_hist(ig,igcm_h2o_ice) = 0.0 
-                     !qsurf_hist(ig,igcm_h2o_vap) = 0.0
                   endif
 
@@ -1675,5 +1550,4 @@
                   if(ice_min(ig).lt.0.01)then
                      qsurf_hist(ig,igcm_h2o_ice) = 0.0 
-                     !qsurf_hist(ig,igcm_h2o_vap) = 0.0
                   endif
 
@@ -1681,11 +1555,6 @@
 
                ! enforce ice conservation
-               ice_tot=0.0
-               do ig = 1, ngrid
-                  ice_tot = ice_tot + qsurf_hist(ig,igcm_h2o_ice)*area(ig)
-               enddo
-               do ig = 1, ngrid
-                  qsurf_hist(ig,igcm_h2o_ice) = qsurf_hist(ig,igcm_h2o_ice)*(icesrf/ice_tot)
-               enddo
+               ice_tot= SUM(qsurf_hist(:,igcm_h2o_ice)*area(:) )
+               qsurf_hist(:,igcm_h2o_ice) = qsurf_hist(:,igcm_h2o_ice)*(icesrf/ice_tot)
 
             endif
@@ -1803,4 +1672,5 @@
 	     call writediagfi(ngrid,"madjdE","heat from moistadj","W m-2",2,madjdE)
 	     call writediagfi(ngridmx,"RH","relative humidity"," ",3,RH)
+	     call writediagfi(ngridmx,"qsatatm","atm qsat"," ",3,qsat)
 	     call writediagfi(ngridmx,"h2o_max_col","maximum H2O column amount","kg.m^-2",2,H2Omaxcol)
           endif 
@@ -1818,16 +1688,12 @@
 
 !     Output aerosols
-        if (igcm_co2_ice.ne.0.and.iaero_co2.ne.0)   &
-           call writediagfi(ngridmx,'CO2ice_reff','CO2ice_reff','m',3, &
-           reffrad(1,1,iaero_co2))
-        if (igcm_h2o_ice.ne.0.and.iaero_h2o.ne.0)   &
-           call writediagfi(ngridmx,'H2Oice_reff','H2Oice_reff','m',3, &
-           reffrad(1,1,iaero_h2o))
-        if (igcm_co2_ice.ne.0.and.iaero_co2.ne.0)   &
-           call writediagfi(ngridmx,'CO2ice_reffcol','CO2ice_reffcol', &
-           'um kg m^-2',2,reffcol(1,iaero_co2))
-        if (igcm_h2o_ice.ne.0.and.iaero_h2o.ne.0)   &
-           call writediagfi(ngridmx,'H2Oice_reffcol','H2Oice_reffcol', &
-           'um kg m^-2',2,reffcol(1,iaero_h2o))
+        if (igcm_co2_ice.ne.0.and.iaero_co2.ne.0) &
+	  call writediagfi(ngridmx,'CO2ice_reff','CO2ice_reff','m',3,reffrad(1,1,iaero_co2))
+        if (igcm_h2o_ice.ne.0.and.iaero_h2o.ne.0) &
+	  call writediagfi(ngridmx,'H2Oice_reff','H2Oice_reff','m',3,reffrad(:,:,iaero_h2o))
+        if (igcm_co2_ice.ne.0.and.iaero_co2.ne.0) &
+	  call writediagfi(ngridmx,'CO2ice_reffcol','CO2ice_reffcol','um kg m^-2',2,reffcol(1,iaero_co2))
+        if (igcm_h2o_ice.ne.0.and.iaero_h2o.ne.0) &
+	  call writediagfi(ngridmx,'H2Oice_reffcol','H2Oice_reffcol','um kg m^-2',2,reffcol(1,iaero_h2o))
 
 !     Output tracers
@@ -1843,7 +1709,7 @@
 
           if(watercond.or.CLFvarying)then
-!             call writediagfi(ngrid,"rneb_man","H2O cloud fraction (conv)"," ",3,rneb_man)
-!             call writediagfi(ngrid,"rneb_lsc","H2O cloud fraction (large scale)"," ",3,rneb_lsc)
-!             call writediagfi(ngrid,"CLF","H2O cloud fraction"," ",3,cloudfrac)
+             call writediagfi(ngrid,"rneb_man","H2O cloud fraction (conv)"," ",3,rneb_man)
+             call writediagfi(ngrid,"rneb_lsc","H2O cloud fraction (large scale)"," ",3,rneb_lsc)
+             call writediagfi(ngrid,"CLF","H2O cloud fraction"," ",3,cloudfrac)
              call writediagfi(ngrid,"CLFt","H2O column cloud fraction"," ",2,totcloudfrac)
           endif
@@ -1877,6 +1743,6 @@
 !      output spectrum 
       if(specOLR.and.corrk)then      
-                 call writediagspecIR(ngrid,"OLR3D","OLR(lon,lat,band)","W/m^2/cm^-1",3,OLR_nu)
-                 call writediagspecVI(ngrid,"OSR3D","OSR(lon,lat,band)","W/m^2/cm^-1",3,OSR_nu)
+         call writediagspecIR(ngrid,"OLR3D","OLR(lon,lat,band)","W/m^2/cm^-1",3,OLR_nu)
+         call writediagspecVI(ngrid,"OSR3D","OSR(lon,lat,band)","W/m^2/cm^-1",3,OSR_nu)
       endif
 
Index: trunk/LMDZ.GENERIC/libf/phystd/radii_mod.F90
===================================================================
--- trunk/LMDZ.GENERIC/libf/phystd/radii_mod.F90	(revision 728)
+++ trunk/LMDZ.GENERIC/libf/phystd/radii_mod.F90	(revision 728)
@@ -0,0 +1,325 @@
+!==================================================================
+module radii_mod
+!==================================================================
+!  module to centralize the radii calculations for aerosols
+! OK for water but should be extended to other aerosols (CO2,...)
+!==================================================================
+      
+!     water cloud optical properties
+      
+      real, save ::  rad_h2o
+      real, save ::  rad_h2o_ice
+      real, save ::  Nmix_h2o
+      real, save ::  Nmix_h2o_ice
+      real, parameter ::  coef_chaud=0.13
+      real, parameter ::  coef_froid=0.09
+
+
+      contains
+
+
+!==================================================================
+   subroutine su_aer_radii(reffrad,nueffrad)
+!==================================================================
+!     Purpose
+!     -------
+!     Compute the effective radii of liquid and icy water particles
+!
+!     Authors
+!     -------
+!     Jeremy Leconte (2012)
+!
+!==================================================================
+ ! to use  'getin'
+      use ioipsl_getincom 
+      use radinc_h, only: naerkind
+      use aerosol_mod
+      Implicit none
+
+#include "callkeys.h"
+#include "dimensions.h"
+#include "dimphys.h"
+#include "tracer.h"
+
+      real, intent(inout) :: reffrad(ngridmx,nlayermx,naerkind)      !aerosols radii (K)
+      real, intent(inout) :: nueffrad(ngridmx,nlayermx,naerkind)     !variance     
+
+      logical, save :: firstcall=.true.
+      integer :: iaer   
+      
+      print*,'enter su_aer_radii'
+          do iaer=1,naerkind
+!     these values will change once the microphysics gets to work
+!     UNLESS tracer=.false., in which case we should be working with
+!     a fixed aerosol layer, and be able to define reffrad in a 
+!     .def file. To be improved!
+
+            if(iaer.eq.iaero_co2)then ! CO2 ice
+               reffrad(1:ngridmx,1:nlayermx,iaer) = 1.e-4
+               nueffrad(1:ngridmx,1:nlayermx,iaer) = 0.1 
+            endif
+
+            if(iaer.eq.iaero_h2o)then ! H2O ice
+               reffrad(1:ngridmx,1:nlayermx,iaer) = 1.e-5
+               nueffrad(1:ngridmx,1:nlayermx,iaer) = 0.1 
+            endif
+
+            if(iaer.eq.iaero_dust)then ! dust
+               reffrad(1:ngridmx,1:nlayermx,iaer) = 1.e-5
+               nueffrad(1:ngridmx,1:nlayermx,iaer) = 0.1 
+            endif
+ 
+            if(iaer.eq.iaero_h2so4)then ! H2O ice
+               reffrad(1:ngridmx,1:nlayermx,iaer) = 1.e-6
+               nueffrad(1:ngridmx,1:nlayermx,iaer) = 0.1 
+            endif
+
+            if(iaer.gt.4)then
+               print*,'Error in callcorrk, naerkind is too high (>4).'
+               print*,'The code still needs generalisation to arbitrary'
+               print*,'aerosol kinds and number.'
+               call abort
+            endif
+
+         enddo
+
+
+         if (radfixed) then
+
+	    write(*,*)"radius of H2O water particles:"
+            rad_h2o=13. ! default value
+            call getin("rad_h2o",rad_h2o)
+            write(*,*)" rad_h2o = ",rad_h2o
+
+	    write(*,*)"radius of H2O ice particles:"
+            rad_h2o_ice=35. ! default value
+            call getin("rad_h2o_ice",rad_h2o_ice)
+            write(*,*)" rad_h2o_ice = ",rad_h2o_ice
+
+	 else
+
+            write(*,*)"Number mixing ratio of H2O water particles:"
+            Nmix_h2o=1.e6 ! default value
+            call getin("Nmix_h2o",Nmix_h2o)
+            write(*,*)" Nmix_h2o = ",Nmix_h2o
+
+            write(*,*)"Number mixing ratio of H2O ice particles:"
+            Nmix_h2o_ice=Nmix_h2o ! default value
+            call getin("Nmix_h2o_ice",Nmix_h2o_ice)
+            write(*,*)" Nmix_h2o_ice = ",Nmix_h2o_ice
+	 endif
+
+      print*,'exit su_aer_radii'
+
+   end subroutine su_aer_radii
+!==================================================================
+
+
+!==================================================================
+   subroutine h2o_reffrad(pq,pt,reffrad,nueffrad)
+!==================================================================
+!     Purpose
+!     -------
+!     Compute the effective radii of liquid and icy water particles
+!
+!     Authors
+!     -------
+!     Jeremy Leconte (2012)
+!
+!==================================================================
+      use radinc_h, only: naerkind
+      use watercommon_h, Only: T_h2O_ice_liq,T_h2O_ice_clouds,rhowater,rhowaterice
+      use aerosol_mod, only : iaero_h2o
+      Implicit none
+
+#include "callkeys.h"
+#include "dimensions.h"
+#include "dimphys.h"
+#include "tracer.h"
+#include "comcstfi.h"
+
+      real, intent(in) :: pq(ngridmx,nlayermx,nqmx) !tracer mixing ratios (kg/kg)
+      real, intent(in) :: pt(ngridmx,nlayermx)      !temperature (K)
+      real, intent(inout) :: reffrad(ngridmx,nlayermx,naerkind)      !aerosols radii (K)
+      real, intent(inout) :: nueffrad(ngridmx,nlayermx,naerkind) ! dispersion      
+
+      integer :: ig,l
+      real zfice ,zrad,zrad_liq,zrad_ice
+      real,external :: CBRT            
+      
+
+      if (radfixed) then
+         do l=1,nlayermx
+            do ig=1,ngridmx
+               zfice = 1.0 - (pt(ig,l)-T_h2O_ice_clouds) / (T_h2O_ice_liq-T_h2O_ice_clouds)
+               zfice = MIN(MAX(zfice,0.0),1.0)
+               reffrad(ig,l,iaero_h2o)= rad_h2o * (1.-zfice) + rad_h2o_ice * zfice
+               nueffrad(ig,l,iaero_h2o) = coef_chaud * (1.-zfice) + coef_froid * zfice
+            enddo
+         enddo
+      else
+         do l=1,nlayermx
+            do ig=1,ngridmx
+               zfice = 1.0 - (pt(ig,l)-T_h2O_ice_clouds) / (T_h2O_ice_liq-T_h2O_ice_clouds)
+               zfice = MIN(MAX(zfice,0.0),1.0)
+	       zrad_liq  = CBRT( 3*pq(ig,l,igcm_h2o_ice)/(4*Nmix_h2o*pi*rhowater) )
+	       zrad_ice  = CBRT( 3*pq(ig,l,igcm_h2o_ice)/(4*Nmix_h2o_ice*pi*rhowaterice) )
+               nueffrad(ig,l,iaero_h2o) = coef_chaud * (1.-zfice) + coef_froid * zfice
+               zrad = zrad_liq * (1.-zfice) + zrad_ice * zfice
+	       reffrad(ig,l,iaero_h2o) = min(max(zrad,1.e-6),100.e-6)
+               enddo
+            enddo      
+      end if
+
+   end subroutine h2o_reffrad
+!==================================================================
+
+
+!==================================================================
+   subroutine h2o_cloudrad(pql,reffliq,reffice)
+!==================================================================
+!     Purpose
+!     -------
+!     Compute the effective radii of liquid and icy water particles
+!
+!     Authors
+!     -------
+!     Jeremy Leconte (2012)
+!
+!==================================================================
+      use watercommon_h, Only: rhowater,rhowaterice
+      Implicit none
+
+#include "callkeys.h"
+#include "dimensions.h"
+#include "dimphys.h"
+#include "tracer.h"
+#include "comcstfi.h"
+
+      real, intent(in) :: pql(ngridmx,nlayermx) !condensed water mixing ratios (kg/kg)
+      real, intent(out) :: reffliq(ngridmx,nlayermx),reffice(ngridmx,nlayermx)     !liquid and ice water particle radii (K)
+
+      real,external :: CBRT            
+      
+
+      if (radfixed) then
+	 reffliq(1:ngridmx,1:nlayermx)= rad_h2o
+	 reffice(1:ngridmx,1:nlayermx)= rad_h2o_ice
+      else
+	 reffliq(1:ngridmx,1:nlayermx)  = CBRT( 3*pql(1:ngridmx,1:nlayermx)/(4*Nmix_h2o*pi*rhowater) )
+	 reffliq(1:ngridmx,1:nlayermx)  = min(max(reffliq(1:ngridmx,1:nlayermx),1.e-6),100.e-6)
+	 reffice(1:ngridmx,1:nlayermx)  = CBRT( 3*pql(1:ngridmx,1:nlayermx)/(4*Nmix_h2o_ice*pi*rhowaterice) )
+	 reffice(1:ngridmx,1:nlayermx)  = min(max(reffice(1:ngridmx,1:nlayermx),1.e-6),100.e-6)
+      end if
+
+   end subroutine h2o_cloudrad
+!==================================================================
+
+
+
+!==================================================================
+   subroutine co2_reffrad(pq,reffrad)
+!==================================================================
+!     Purpose
+!     -------
+!     Compute the effective radii of co2 ice particles
+!
+!     Authors
+!     -------
+!     Jeremy Leconte (2012)
+!
+!==================================================================
+      use radinc_h, only: naerkind
+      use aerosol_mod, only : iaero_co2
+      Implicit none
+
+#include "callkeys.h"
+#include "dimensions.h"
+#include "dimphys.h"
+#include "tracer.h"
+#include "comcstfi.h"
+
+      real, intent(in) :: pq(ngridmx,nlayermx,nqmx) !tracer mixing ratios (kg/kg)
+      real, intent(inout) :: reffrad(ngridmx,nlayermx,naerkind)      !aerosols radii (K)
+
+      integer :: ig,l
+      real :: zrad   
+      real,external :: CBRT            
+            
+      
+
+      if (radfixed) then
+         reffrad(1:ngridmx,1:nlayermx,iaero_co2) = 5.e-5 ! CO2 ice
+      else
+         do l=1,nlayermx
+            do ig=1,ngridmx
+               zrad = CBRT( 3*pq(ig,l,igcm_co2_ice)/(4*Nmix_co2*pi*rho_co2) )
+               reffrad(ig,l,iaero_co2) = min(max(zrad,1.e-6),100.e-6)
+            enddo
+         enddo      
+      end if
+
+   end subroutine co2_reffrad
+!==================================================================
+
+
+
+!==================================================================
+   subroutine dust_reffrad(reffrad)
+!==================================================================
+!     Purpose
+!     -------
+!     Compute the effective radii of dust particles
+!
+!     Authors
+!     -------
+!     Jeremy Leconte (2012)
+!
+!==================================================================
+      use radinc_h, only: naerkind
+      use aerosol_mod, only : iaero_dust
+      Implicit none
+
+#include "callkeys.h"
+#include "dimensions.h"
+#include "dimphys.h"
+
+      real, intent(inout) :: reffrad(ngridmx,nlayermx,naerkind)      !aerosols radii (K)
+            
+      reffrad(1:ngridmx,1:nlayermx,iaero_dust) = 2.e-6 ! dust
+
+   end subroutine dust_reffrad
+!==================================================================
+
+
+!==================================================================
+   subroutine h2so4_reffrad(reffrad)
+!==================================================================
+!     Purpose
+!     -------
+!     Compute the effective radii of h2so4 particles
+!
+!     Authors
+!     -------
+!     Jeremy Leconte (2012)
+!
+!==================================================================
+      use radinc_h, only: naerkind
+      use aerosol_mod, only : iaero_h2so4
+      Implicit none
+
+#include "callkeys.h"
+#include "dimensions.h"
+#include "dimphys.h"
+
+      real, intent(inout) :: reffrad(ngridmx,nlayermx,naerkind)      !aerosols radii (K)
+                
+      reffrad(1:ngridmx,1:nlayermx,iaero_h2so4) = 1.e-6 ! h2so4
+
+   end subroutine h2so4_reffrad
+!==================================================================
+
+
+
+end module radii_mod
+!==================================================================
Index: trunk/LMDZ.GENERIC/libf/phystd/radinc_h.F90
===================================================================
--- trunk/LMDZ.GENERIC/libf/phystd/radinc_h.F90	(revision 726)
+++ trunk/LMDZ.GENERIC/libf/phystd/radinc_h.F90	(revision 728)
@@ -51,6 +51,6 @@
 !		can in princple be anything: currently it's H2O.
 !
-!     NAERKIND  The number of radiatively active species
-!               (set in scatterers.h ; built when compiling with makegcm -s #)
+!     NAERKIND  The number of radiatively active aerosol types
+!
 !     NSIZEMAX  The maximum number of aerosol particle sizes
 !
@@ -76,5 +76,5 @@
       ! equivalent temperatures are 1/NTfac of these values
       integer, parameter :: NTstar = 500
-      integer, parameter :: NTstop = 9000 ! new default for all non hot Jupiter runs
+      integer, parameter :: NTstop = 15000 ! new default for all non hot Jupiter runs
       real*8, parameter :: NTfac = 1.0D+1  
       !integer, parameter :: NTstar = 1000
